#!/usr/bin/perl
#
# Converts any file from 8 bit bytes to 3 bit notes. Why? Who knows...
#
# Version 1.0
#
#==========================================================================
# Copyright (c) 2003 by R. Steven Rainwater <steve@ncc.com>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
#==========================================================================

use strict;
use MIDI::Simple;

unless($ARGV[0] && $ARGV[1]) {
  print "Usage:\nbyte2note infile outfile [instrument] [note1]\n",
        "instrument = General MIDI Instrument 1-127 (default 1)\n",
	"note1 = Starting MIDI note 0-120 (default 60)\n";
}

my $b = 0;
my $n = 0;
my $pad = "0" x 32;
my $bytes = '';
my $instrument = $ARGV[2] || 1;
my $note1 = $ARGV[3] || 60;
my $note = 0;

new_score;
set_tempo 500000;
patch_change 1, $instrument;
noop 'c1', 'f';

if(open DF, $ARGV[0]) {
  while($b = read DF, $bytes, 3) {
    if($b < 3) { $bytes .= ("\x00" x (3 - $b)); }
    $n = unpack "B24", $bytes;
    foreach(unpack "a3a3a3a3a3a3a3a3", $n) {
      $note = unpack "N", pack "B32", substr($pad . $_, -32);
      print "[$_][$note]\n";
      n 'en', $note1+$note;      
    }
    print "\n";
  }
  close DF;

  write_score $ARGV[1];
}
